import Data.Numbers.Primes
import Criterion.Main
import ECL

dhStart :: CryptoM
dhStart = update (cm0for [alice,bob,eve]) (Open eve)

dhCommandList :: (Integer,Integer,Integer,Integer) -> Integer -> [Com]
dhCommandList (popen,gopen,asecret,bsecret) regmax = [
  CreateSized (Q 1) alice (Nmbr asecret) regmax,
  CreateSized (R 1) alice (PowerMod (Nmbr gopen) (PrpE (Q 1)) (Nmbr popen)) regmax,
  (Open bob), (Announce (R 1)), (Close bob),
  CreateSized (Q 2) bob (Nmbr bsecret) regmax,
  CreateSized (R 2) bob (PowerMod (Nmbr gopen) (PrpE (Q 2)) (Nmbr popen)) regmax,
  (Open alice), (Announce (R 2)), (Close alice),
  CreateSized (S 1) alice (PowerMod (PrpE (R 2)) (Nmbr asecret) (Nmbr popen)) regmax,
  CreateSized (S 2) bob (PowerMod (PrpE (R 1)) (Nmbr bsecret) (Nmbr popen)) regmax
  ]

dhCommand :: (Integer,Integer,Integer,Integer) -> Integer -> Com
dhCommand (popen,gopen,asecret,bsecret) regmax =
  if and [ isPrime popen, gopen <= popen, gcd (popen-1) gopen == 1 ]
    then lst2cmd $ dhCommandList (popen,gopen,asecret,bsecret) regmax
    else error ("Invalid Diffie-Hellman parameters!")

dhGoal :: Form
dhGoal = Conj [
  Equal (PrpE (S 1)) (PrpE (S 2)),
  K alice (PrpF (S 1)), K bob (PrpF (S 2)),
  Neg (K eve (PrpF (S 1))), Neg (K eve (PrpF (S 2)))
  ]

dhSample :: (Integer,Integer,Integer,Integer)
dhSample = (23,5,6,15)
allPrimes :: [Integer]
allPrimes = filter (registersize >) (take (fromIntegral registersize) primes)
dhAllSamples :: [(Integer,Integer,Integer,Integer)]
dhAllSamples = [ (p,g,a,b) | p <- allPrimes, g<-allN, a<-allN, b<-allN ]
  where allN = [0..registersize]

main :: IO ()
main = defaultMain $ concat [ [
  bench (show n) $ nf (eval   dhStart) (Com (dhCommand dhSample (2^n)) dhGoal),
  bench (show n) $ nf (evalMC dhStart) (Com (dhCommand dhSample (2^n)) dhGoal)
  ] | n <- [8..(16::Integer)] ]

