import Data.Numbers.Primes
import ECL

dhMitmStart :: CryptoM
dhMitmStart = cm0for [alice,bob,mallory]

dhMitmCommandList :: (Integer,Integer,Integer,Integer,Integer) -> Integer -> [Com]
dhMitmCommandList (popen,gopen,asecret,bsecret,msecret) rs = [
  CreateSized (R 1) alice (PowerMod (Nmbr gopen) (Nmbr asecret) (Nmbr popen)) rs,
  Open mallory, Announce (R 1), Close mallory,
  CreateSized (R 11) mallory (PowerMod (Nmbr gopen) (Nmbr msecret) (Nmbr popen)) rs,
  Open bob, Announce (R 11), Close bob,
  CreateSized (R 2) bob (PowerMod (Nmbr gopen) (Nmbr bsecret) (Nmbr popen)) rs,
  Open mallory, Announce (R 2), Close mallory,
  CreateSized (R 22) mallory (PowerMod (Nmbr gopen) (Nmbr msecret) (Nmbr popen)) rs,
  Open alice, Announce (R 22), Close alice,
  CreateSized (S 1)  alice   (PowerMod (PrpE (R 22)) (Nmbr asecret) (Nmbr popen)) rs,
  CreateSized (S 2)  bob     (PowerMod (PrpE (R 11)) (Nmbr bsecret) (Nmbr popen)) rs,
  CreateSized (S 11) mallory (PowerMod (PrpE (R 1))  (Nmbr msecret) (Nmbr popen)) rs,
  CreateSized (S 22) mallory (PowerMod (PrpE (R 2))  (Nmbr msecret) (Nmbr popen)) rs
  ]

dhMitmCommand :: (Integer,Integer,Integer,Integer,Integer) -> Integer -> Com
dhMitmCommand (popen,gopen,asecret,bsecret,msecret) rs =
  if and [ isPrime popen, gopen <= popen, gcd (popen-1) gopen == 1 ]
    then lst2cmd $ dhMitmCommandList (popen,gopen,asecret,bsecret,msecret) rs
    else error ("Invalid Diffie-Hellman parameters!")

dhMitmSample :: (Integer,Integer,Integer,Integer,Integer)
dhMitmSample = (23,5,6,15,13)

dhMitmGoal :: Form
dhMitmGoal = Conj [
  Neg $ Equal (PrpE (S 1)) (PrpE (S 2)),
  Equal (PrpE (S 1)) (PrpE (S 11)),
  Equal (PrpE (S 2)) (PrpE (S 22)),
  K mallory (PrpF (S 11)),
  K mallory (PrpF (S 22))
  ]

main :: IO ()
main = do
  putStr $ stepwiseUpdateEvalMC dhMitmStart (dhMitmCommandList dhMitmSample registersize) dhMitmGoal

