module ECLEXAMPLE where
import ECL

m0 :: CryptoM
m0 = cm0for [alice,bob]

m1 :: CryptoM
m1 = update m0 (Create (Q 0) alice (Nmbr 7) :- Create (P 0) bob (Nmbr 4))

equality, tautology :: Form
equality  = Equal (PrpE (P 0)) (PrpE (Q 0))
tautology = disj [ equality, Neg equality ]

mL :: CryptoM
mL = update (cm0for [alice,bob]) (Open alice :- Open bob)

mAttention0, mAttention1, mAttention2, mAttention3, mAttention4, mAttention5 :: CryptoM

mAttention0 = cm0for [alice,bob,carol]
mAttention1 = update mAttention0 (Open alice)

mAttention2 = update mAttention1 (Open bob)

mAttention3 = update mAttention2 (Open carol)

mAttention4 = update mAttention3 (Open bob)
mAttention5 = update mAttention4 (Open alice)

main :: IO ()
main = do
  s1 <- eclTexModel m0 "ECLm0"
  putStrLn s1
  s2 <- eclTexModel m1 "ECLm1"
  putStrLn s2
  s3 <- eclTexModel mAttention0 "mAttention0"
  putStrLn s3
  s4 <- eclTexModel mAttention1 "mAttention1"
  putStrLn s4
  s5 <- eclTexModel mAttention2 "mAttention2"
  putStrLn s5
  s6 <- eclTexModel mAttention3 "mAttention3"
  putStrLn s6
  s7 <- eclTexModel mAttention4 "mAttention4"
  putStrLn s7
  s8 <- eclTexModel mAttention5 "mAttention5"
  putStrLn s8
  putStrLn "Done."

